#pragma config(Sensor, S1,     ,               sensorEV3_Color)
#pragma config(Sensor, S2,     ,               sensorEV3_Color)
#pragma config(Sensor, S3,     ,               sensorEV3_Color)
#pragma config(Motor,  motorB,          B,             tmotorEV3_Large, openLoop, reversed, encoder)
#pragma config(Motor,  motorC,          C,             tmotorEV3_Large, openLoop, reversed, encoder)
//*!!Code automatically generated by 'ROBOTC' configuration wizard               !!*//

int v=70;
int eold=0;
int iMax=20;
int last=2;
float kp=0.5;
float kd=0.5;
float ki=0.05;
float i=0;
float p;
float d;
float u;
int greyLeft;
int greyCentred;
int greyRight;
int e;
int sv1;
int sv2;
int sv3;

void cal()
{
	int whiteLeft=0;
	int blackLeft=100;

	int whiteCentred=0;
	int blackCentred=100;

	int whiteRight=0;
	int blackRight=100;

	while (!getButtonPress(buttonUp)) sleep(1);

	motor[B]=50;
	motor[C]=-50;
	nMotorEncoder[B]=0;

	while(abs(nMotorEncoder[B])<800)
	{
		int svetLeft=SensorValue[S1];
		if (svetLeft>whiteLeft) whiteLeft=svetLeft;
		if (svetLeft<blackLeft)	blackLeft=svetLeft;

		int svetCentred=SensorValue[S2];
		if (svetCentred>whiteCentred) whiteCentred=svetCentred;
		if (svetCentred<blackCentred) blackCentred=svetCentred;

		int svetRight=SensorValue[S3];
		if (svetRight>whiteRight) whiteRight=svetRight;
		if (svetRight<blackRight)	blackRight=svetRight;
		sleep(1);
	}

	motor[B]=motor[C]=0;
	greyLeft=(whiteLeft+blackLeft)/2;
	greyCentred=(whiteCentred+blackCentred)/2;
	greyRight=(whiteRight+blackRight)/2;
	playSound(soundBeepBeep);
	while (!getButtonPress(buttonUp)) sleep(1);
}

void PID()
{
	e=(sv1-greyRight)-(sv3-greyLeft);
	p=e*kp;
	i=i+e*ki;
	if(abs(i)>iMax) i=sgn(i)*iMax;
	d=(e-eold)*kd;
	u=p+d;
	eold=e;
}

void rele()
{
	PID();

	if(sv1<greyLeft)
	{
		last=1;
		clearTimer(T1);
	}

	else if(sv2<greyCentred)
	{
		last=2;
		clearTimer(T1);
	}

	else if(sv3<greyRight)
	{
		last=3;
		clearTimer(T1);
	}

	else if(time1(T1)>200)
	{
		u=(last-2)*v;
	}

	motor[B]=v+u;
	motor[C]=v-u;
	sleep(5);
}

task main()
{
	cal();

	while(true)
	{
		sv1=SensorValue[S1];
		sv2=SensorValue[S2];
		sv3=SensorValue[S3];
		rele();
	}
}
